// Constructor.
function Channel(id,widgetOb){
	this.init(id,widgetOb);
}   

Channel.prototype.id = null;
Channel.prototype.templateMode = null;
Channel.prototype.feedItemControls = null;
Channel.prototype.feedItemControlsLs = null;
Channel.prototype.mainPageItemControls = null;
Channel.prototype.mainPageItemControlsLs = null;
Channel.prototype.feedItemControlPool = null;
Channel.prototype.mainPageItemControlPool = null;
Channel.prototype.feedItemControlPoolLs = null;
Channel.prototype.mainPageItemControlPoolLs = null;
Channel.prototype.timestamps = null;
Channel.prototype.currentPage = null;
Channel.prototype.countPage = null;
Channel.prototype.currentStory = null;
Channel.prototype.countStory = null;
Channel.prototype.mainView = null;
Channel.prototype.storiesView = null;
Channel.prototype.mainViewLs = null;
Channel.prototype.storiesViewLs = null;
Channel.prototype.feedUpdateTime = null;
Channel.prototype.shareUrl= null;;
Channel.prototype.feedLastModified = null;
Channel.prototype.pageSeen = null;
Channel.prototype.currentItems = null;
Channel.prototype.arrayThumbs = null;
Channel.prototype.arrayThumbsSrc = null;
Channel.prototype.arrayImages = null;
Channel.prototype.arrayImagesSrc = null;
Channel.prototype.arrayImagesList = null;
Channel.prototype.arrayImagesListSrc = null;
Channel.prototype.mippinUpdate = null;
Channel.prototype.mippinUpdateStart = null;
Channel.prototype.widgetOb = null;
Channel.prototype.isUpdating = null;
Channel.prototype.templateMode = null;


Channel.prototype.init = function(id,widgetOb){
	this.feedItemControls = new Array(20);
	this.feedItemControlsLs = new Array(20);
	this.mainPageItemControls = new Array(1);
	this.mainPageItemControlsLs = new Array(1);
	this.feedItemControlPool = [];
	this.mainPageItemControlPool = [];
	this.feedItemControlPoolLs = [];
	this.mainPageItemControlPoolLs = [];
	this.timestamps = new Array(20);
	this.currentPage = 0;
	this.countPage = 0;
	this.currentStory = 0;
	this.countStory = 0;
	this.mainView;
	this.storiesView;
	this.mainViewLs;
	this.storiesViewLs;
	this.feedUpdateTime = -1;
	this.shareUrl;
	this.shareTitle;
	this.pageSeen = new Array(20);
	this.currentItems = [];
	this.arrayThumbs = new Array(20);
	this.arrayThumbsSrc = new Array(20);
	this.arrayImages = new Array(20);
	this.arrayImagesSrc = new Array(20);
	this.arrayImagesList = new Array(20);
	this.arrayImagesListSrc = new Array(20);
	this.mippinUpdateStart = 0;
	this.isUpdating = false;
	
	this.id = id;
	this.widgetOb = widgetOb;
	this.shareUrl = mippinUrl;
	this.shareTitle='Ovi app wizard';
	this.feedUpdateTime = 0;
    this.mainView = new ListViewMippin(null, "Main view"+id);
    this.storiesView = new ListViewMippin(null, "Stories view"+id);
    this.mainViewLs = new ListViewMippin(null, "MainLs view"+id);
    this.storiesViewLs = new ListViewMippin(null, "StoriesLs view"+id);
   
    var lastUpdate = window.widget.preferenceForKey(mippinID+"lastUpdate_c"+this.id); 
    if (lastUpdate!=null) {
    	var now = new Date().getTime();
    	 var diff = now - lastUpdate;
    	 if (diff < feedUpdateFrequency){
    		 this.feedUpdateTime = now + (feedUpdateFrequency-diff);
    		 setTimeout("setFeedItemsForChannel("+this.id+",null)",500);
    	 } else this.feedUpdateTime = 0;
    } else this.feedUpdateTime = 0;
	
	
	/*bill+*/
	try {
		this.templateMode = window.widget.preferenceForKey(mippinID + "channelTemplate_c" + this.id);
	}
	catch(err) {
		this.templateMode = 0;
	}
	
	
}

Channel.prototype.getMainView = function(){
	return this.mainView;
} 

Channel.prototype.getStoriesView = function(){
	return this.storiesView;
} 
Channel.prototype.getMainViewLs = function(){
	return this.mainViewLs;
} 
Channel.prototype.getStoriesViewLs = function(){
	return this.storiesViewLs;
} 
Channel.prototype.getCurrentItems = function(){
	return this.currentItems;
} 
Channel.prototype.getTimestamps = function(){
	return this.timestamps;
} 
Channel.prototype.getArrayThumbs = function(){
	return this.arrayThumbs;
} 
Channel.prototype.getArrayThumbsSrc = function(){
	return this.arrayThumbsSrc;
} 
Channel.prototype.getCurrentStory = function(){
	return this.currentStory;
}
  

Channel.prototype.setFeedItems = function(items,show){
	if (items==null) {
		if (this.currentItems!=null && this.currentItems.length>0) return;
	  	items =  this.readAllItems();
	  var count=0;
	  if (items!=null) count=items.length;
//	  uiManager.showNotification(3000, "error", "loading saved items : " + count);
//      showNoti("loading saved items : " + count,3000);
	  this.currentItems = items;
      if (items==null) return; 
	  	
	} else {
		if (uiManager.getView() == this.storiesView || uiManager.getView() == this.storiesViewLs) {
			channelsToUpdate[this.id] = items;
			return true;
		}
		this.currentItems = items;
    	setTimeout("saveAllCurrentItemsForChannel("+this.id+")", 15000);
	}
	// start by removing all current feed items
    this.removeAllItems();
    this.clearAdArray();
    
    // create new feed items and add them to the main view
    // use feed item pool to recycle controls
   var ficp = this.feedItemControlPool; 
   var ficpLs = this.feedItemControlPoolLs; 
   var at = this.arrayThumbsSrc;
   var ai = this.arrayImagesSrc;
   var ath = this.arrayThumbs;
   var ail = this.arrayImagesListSrc;
   var t = this.timestamps;
   var length = items.length;
   var fic = this.feedItemControls;
   var ficLs = this.feedItemControlsLs;
   
    for (var i = 0; i < length; i++) {
        // get a feed item control from the pool or create one and
        // place it in the pool if there aren't enough feed item controls
        var feedItemControl;
        if (i == ficp.length) {
        	feedItemControl = new SlideShowPanel(null, null, null, true,false);
        	ficp.push(feedItemControl);
        } else {
            feedItemControl = ficp[i];
        }
       
	    var feedItemControlLs;
        if (i == ficpLs.length) {
        	feedItemControlLs = new SlideShowPanel(null, null, null, true,false);
        	ficpLs.push(feedItemControlLs);
        } else {
            feedItemControlLs = ficpLs[i];
        }
       
	    
        // initialize feed item control
        var item = items[i];
        
		/*bill*/
         if (item.imageThumb!=null) {
        	 at[i] = item.imageThumb.replace("w=80", "w=90").replace("h=60", "h=90");
        	 if (i<10) {
        		 ath[i] = new Image();
        		 ath[i].src = at[i];
        	 }
        	 ail[i] = item.imageThumb.replace("w=80", "w=90").replace("h=60", "h=90");
         }
         if (item.image) {
        	 ai[i] =item.image;
         }
         
        t[i] = getTextForTimestamp(item);
        
        var buf = this.getContentHTMLForFeedItem(item, i, false);
        feedItemControl.setContent(buf);
        feedItemControl.setVisible(false);
        
		var bufLs = this.getContentHTMLForFeedItem(item, i, true);
        feedItemControlLs.setContent(bufLs);
        feedItemControlLs.setVisible(false);
		
        // add the feed item control to the main view
        fic[i]=feedItemControl;
        this.storiesView.addControl(feedItemControl, i);
        
		ficLs[i]=feedItemControlLs;
        this.storiesViewLs.addControl(feedItemControlLs, i);
        
    }
    this.countStory = items.length;
    
	var mainPageItemControl;
	var mainPageItemControlLs;
	var page=0;
	var mpicp = this.mainPageItemControlPool;
    var mpicpLs = this.mainPageItemControlPoolLs;
    if (page == mpicp.length) {
    	mainPageItemControl = new SlideShowPanel(null, null, null, true,false);
    	mpicp.push(mainPageItemControl);
    } else {
        mainPageItemControl = mpicp[page];
    }
    if (page == mpicpLs.length) {
    	mainPageItemControlLs = new SlideShowPanel(null, null, null, true,false);
    	mpicpLs.push(mainPageItemControlLs);
    } else {
        mainPageItemControlLs = mpicpLs[page];
    }
	/*bill++ changed false to true*/
    var buf = this.getContentHTMLForFeedItemList(items, -1,true);
    mainPageItemControl.setContent(buf);
    mainPageItemControl.setVisible(false);
    this.mainPageItemControls[page]=mainPageItemControl;
    this.mainView.addControl(mainPageItemControl, "p" + page);
    var bufLs = this.getContentHTMLForFeedItemList(items, -1,true);
    mainPageItemControlLs.setContent(bufLs);
    mainPageItemControlLs.setVisible(false);
    this.mainPageItemControlsLs[page]=mainPageItemControlLs;
    this.mainViewLs.addControl(mainPageItemControlLs, "p" + page);
    this.countPage = page+1;
    this.setTitle();
	if (currentChannel==this.id) {
		if (show) this.setMainPageVisible(0,true);
		setTimeout("hideWaiter("+this.id+")", 1000);
	}
	return false;
}

Channel.prototype.refreshViews = function(){
	this.mainView.refreshView(true,this.mainPageItemControls);
	this.mainViewLs.refreshView(true,this.mainPageItemControlsLs);
	this.storiesView.refreshView(false,this.feedItemControls);
	this.storiesViewLs.refreshView(false,this.feedItemControlsLs);
}

// Returns the content HTML for a feed item.
Channel.prototype.getContentHTMLForFeedItem = function(item, i, isLs){
    
	
	//--------------------------------------------------------------------------------------------- GALLERY IMAGE VIEW
	if (this.templateMode == 1) {
		var buf = "";
		var ais = this.arrayImagesSrc;
		var ats = this.arrayThumbsSrc;
		
		var newImgSrc = "imagesNew/thumb_broken360x360.png";
		var onLoadOnErrorActions = "";
		if ((ais[i] != "undefined") && (ais[i] != "") && (ais[i] != null)) {
			newImgSrc = ais[i].replace("w=308", "w=360");
			onLoadOnErrorActions = " onload='ImgLoadGallery(this)' onerror='ImgErrorGallery(this) ";
		}
		
		buf += "<div id='galleryContainer'>";
		
		buf += "<div id='galleryTopContainer'>";
		buf += "	<div id='galleryImageTopBar'>";
		buf += "		<a href='#' onclick='javascript:previousSlide();'><div style='float:left; width:60px; height:47px;'></div></a>";
		buf += "		<a href='#' onclick='javascript:nextSlide();'><div style='float:left; width:60px; height:47px;'></div></a>";
		buf += "		<a href='#' onclick='javascript:runHome();'><div style='float:right; width:60px; height:47px;'></div></a>";
		buf += "	</div>";
		buf += "</div>";
		
		var videoEnclosure = "";
		if ((item.enclosure != null) && (item.enclosure != "")) {
			var vurl = item.enclosure;
			if ((vurl.indexOf('mp4') > -1) || (vurl.indexOf('mp3') > -1) || (vurl.indexOf('3gp') > -1) || (vurl.indexOf('youtube.com/watch') > -1)) {
				vurl = vurl;
			}
			else {
				vurl = "http://" + domain + "/mip/m/offsite.jsp?id=1&amp;type=3&amp;url=" + escape("http://blueapple.mobi/tpw?url=" + escape(vurl.replace("&amp;", "&").replace("%3D", "=")) + "&t=" + escape(item.title) + "&bl=" + backLink + "&b=0");
			}
			videoEnclosure = unescape(vurl).replace('"', '%22');
		}
		

		
		
		buf += "<a href='#' style='border:3px solid green' onclick='javascript:ToggleGalleryMode(this.parentNode)'>";
		buf += "	<div id=\"galleryImageArticleContainer\">";
		buf += "		<div class=\"wraptocenter\">";
		buf += "				<img onclick='javascript:LoadVideoUrlIfValid(\"" + videoEnclosure + "\");' class='galleryImageArticleImgElement' src='" + newImgSrc + "'" + onLoadOnErrorActions + "'/><span></span>";
		buf += "		</div>";
		buf += "	</div>";
		buf += "<a/>";
		
		
		buf += "<div id='galleryBottomContainer'>";
		buf += "	<div class='galleryImageArticleTextContainerBottom minimized'>";
		/*buf += "		<div style='float:right; width:90px; height:60px;' onclick='javascript:toggleGalleryDescriptionBar();' >";
		buf += "		</div>";*/
		buf += "		<a href='#' onclick='javascript:toggleGalleryDescriptionBar();'><div class=\"galleryArticleTitle\">" + item.title + "</div></a>";
		buf += "		<div class=\"galleryArticleDescription\">";
		buf += "			<div style='min-height:80px'>" + item.description + "</div>";
		buf += "			<div style='background:transparent; padding-left:0px;' id='sharingButtonsArticle'>";
		if (ucc != "cn") {
			buf += "			<a id='FacebookText' class='whiteLink' href='#' onclick='javascript:sendFacebook();'><img src='imagesNew/share_fbook.png' style='vertical-align:middle'/></a>		\
								<a id='TwitterText' class='whiteLink' href='#' onclick='javascript:sendTwitter();'><img src='imagesNew/share_twitter.png' style='vertical-align:middle'/></a>";
		}
		buf += "				<a id='SmsText' class='whiteLink' href='#' onclick='javascript:sendSMS();'><img src='imagesnew/share_sms.png' style='vertical-align:middle'></a>		\
								<a id='EmailText' class='whiteLink' href='#' onclick='javascript:sendEmail();'><img src='imagesNew/share_email.png' style='vertical-align:middle'/></a>		\
							</div>";
		buf += "		</div>"
		buf += "	</div>";
		buf += "</div>";
		
		buf += "</div>";
		
		
		return buf;
	}
	//--------------------------------------------------------------------------------------------- NORMAL ARTICLE VIEW
	else {
	
		var buf = HeaderImageHTML();
		
		
		
		buf += "<div class=\"storyBlock\">";
		
		/*bill - this line is outside div*/
		buf += getAdBody(i, 1);
		
		var add = "";
		if (item.title != null) {
			buf += "<div class=\"font_headline_storyview\">" + add + item.title + "</div>";
		}
		var ais = this.arrayImagesSrc;
		if (item.enclosure != null) {
			if (isLs) 
				buf += "<span class=\"videoLinkLs\">";
			else 
				buf += "<div class=\"videoLink\"><center>";
			
			var vurl = item.enclosure;
			var backLink = "javascript:window.close()";
			if ((vurl.indexOf('mp4') > -1) || (vurl.indexOf('mp3') > -1) || (vurl.indexOf('3gp') > -1) || (vurl.indexOf('youtube.com/watch') > -1)) {
				vurl = vurl;
			}
			else {
				vurl = "http://" + domain + "/mip/m/offsite.jsp?id=1&amp;type=3&amp;url=" + escape("http://blueapple.mobi/tpw?url=" + escape(vurl.replace("&amp;", "&").replace("%3D", "=")) + "&t=" + escape(item.title) + "&bl=" + backLink + "&b=0");
			}
			var ats = this.arrayThumbsSrc;
			if (ais[i] == null && ats[i] != null) {
				buf += "<a id=\"image_ail_" + i + "\" href=\"JavaScript:window.widget.openURL('" + vurl + "')\"></a><br/>";
			}
			
			if (isLs) 
				buf += "<center>"
			buf += "<a href=\"JavaScript:window.widget.openURL('" + vurl + "')\" >";
			buf += "<div id=\"image_ai_" + i + "\" class=\"FeedImage\"></div>"
			buf += viewVideo;
			buf += "</a>";
			
			if (isLs) 
				buf += "</center></span>";
			else 
				buf += "</center></div>";
				
			//change parameter w=308
			ais[i] = ais[i].replace("w=308", "w=340");
		}
		else 
			if (ais[i] != null) {
				if (isLs && (item.audio == null || item.audio.length == 0)) 
					buf += "<span id=\"image_ai_" + i + "\" class=\"FeedImageLs\"></span>";
				else 
					buf += "<div id=\"image_ai_" + i + "\" class=\"FeedImage\"></div>";
			}
		
		if (item.audio != null && item.audio.length > 0) {
			buf += "<div style=\"height: 5px;clear: both;\"></div>";
			for (var k = 0; k < item.audio.length; k++) {
				var splitted = item.audio[k].split("/");
				buf += "<div class=\"lineBottom\"></div>";
				buf += "<div class=\"audioLink\" onclick=\"JavaScript:window.widget.openURL('" + item.audio[k] + "')\"><table cellpadding=\"0\" cellspacing=\"0\"><tr><td><div class=\"audioLinkImg\"></div></td><td valign=\"center\"><span class=\"audioLinkTitle\">" + downloadAudio + "</span><br/><span class=\"audioLinkName\">" + splitted[splitted.length - 1].replace(/%20/g, " ") + "</span></td></tr></table></div>"
			}
			buf += "<div class=\"lineBottom\"></div>";
			
			/*				buf += "<div class=\"audioLink\" onclick=\"JavaScript:window.widget.openURL('" + item.audio[k] + "')\">\
							<table>\
								<tr>\
									<td style='width:60px;'>\
										<div class=\"audioLinkImg\"></div>\
									</td>\
									<td style='width:300px' valign=\"center\" align=\"right\">\
										<span class=\"audioLinkName\">" + splitted[splitted.length - 1].replace(/%20/g, " ") + "</span></br>\
										<div class=\"audioLinkTitle\">download</div>\
									</td>\
								</tr>\
							</table>\
						</div>";*/
		}
		
		var ts = this.timestamps[i];
		
		if (ts != null) {
			if (isLs) 
				buf += "<span class=\"font_timestamp_storyview\">" + ts + "</span><br/>";
			else 
				buf += "<div class=\"font_timestamp_storyview\">" + ts + "</div>";
		}
		
		// item description
		if (item.description != null) {
			//var desc = item.description.replace(/\. /g,".<br/><br/>");
			var desc = item.description;
			if (isLs) 
				buf += "<span class=\"font_story_storyview\">" + desc + "</span>";
			else 
				buf += "<div class=\"font_story_storyview\">" + desc + "</div>";
		}
		
		
		// item URL
		if ((item.url != null) && (item.url != "") && (item.url != "null/")) {
			buf += "<br/><a class=\"fontOriginalLink\" href=\"JavaScript:window.widget.openURL('" + item.url + "') \" >";
			buf += seeOriginalStory;
			buf += "</a><br/><br/>";
		}
		else {
			buf += "<br/><br/><br/><br/><br/><br/><br/><br/><br/>";
		}
		
		
		buf += "</div>";
		
		
		
		
		//add sharing buttons
		/*bill*/
		buf += "\
			<div style='clear:both' id='sharingButtonsArticle'>\
			 	<span style='padding-right:10px;'>" + share + "</span>";
		if (ucc != "cn") {
			buf += "		<a id='FacebookText' class='whiteLink' href='#' onclick='javascript:sendFacebook();'><img src='imagesNew/share_fbook.png' style='vertical-align:middle'/></a>		\
							<a id='TwitterText' class='whiteLink' href='#' onclick='javascript:sendTwitter();'><img src='imagesNew/share_twitter.png' style='vertical-align:middle'/></a>";
		}
		buf += "			<a id='SmsText' class='whiteLink' href='#' onclick='javascript:sendSMS();'><img src='imagesnew/share_sms.png' style='vertical-align:middle'></a>		\
							<a id='EmailText' class='whiteLink' href='#' onclick='javascript:sendEmail();'><img src='imagesNew/share_email.png' style='vertical-align:middle'/></a>		\
			</div>	\
			<div id='previousNextButtonsContainer'>\
				<a href='#' onclick='javascript:previousSlide();'><div style='float:left' class='previousButtons'></div></a>\
				<a href='#' onclick='javascript:nextSlide();'><div style='float:right' class='nextButtons'></div></a>\
				<div class='currentArticleTotalArticles'>" + (i + 1) + "/" + this.currentItems.length + "</div>\
			</div>" + 
			getAdBody(i, 2) +
			OviBarHTMLcode();
		
		
		
		
		// adding add to each story
		
		return buf;
	}
}


var _galleryImageClicked = false;

function LoadVideoUrlIfValid(videoUrl) {
	if ((videoUrl != null) && (videoUrl != "")) {
		window.widget.openURL(videoUrl);
		_galleryImageClicked = true;
	}
}

function ToggleGalleryMode(top) {
	if (_galleryImageClicked) {
		_galleryImageClicked = false;
		return;
	}
	if ( top!= null) {
		if (top.className == "hiddenGalleryButtons")
			top.className = "visibleGalleryButtons";
		else
			top.className = "hiddenGalleryButtons";
	}
}

function ImgError(source){
	source.onerror = "";
	source.onload = "";
	source.src = "imagesNew/thumb_broken.png";
	return true;
}

function ImgErrorGallery(source){
	source.onerror = "";
	source.onload = "";
	source.src = "imagesNew/thumb_broken360x360.png";
	return true;
}

function ImgLoadGallery(source){
	if (source.width == 0) {
		source.onerror = "";
		source.onload = "";
		source.src = "imagesNew/thumb_broken360x360.png";
	}
	return true;
}

function ImgLoad(source) {
	if (source.width == 0) {
		source.onerror = "";
		source.onload = "";
		source.src = "imagesNew/thumb_broken.png";
	}
	return true;
}



Channel.prototype.getContentHTMLForFeedItemList = function(items, page, isLs){
	
	var startInd = 0 + (page * 10);
	var endInd = 10 + (page * 10);
	if (endInd > items.length) 
		endInd = items.length;
	if (page == -1) {
		startInd = 0;
		endInd = items.length;
	}
	var ats = this.arrayThumbsSrc;
	var add = "";
	var test = false;
	if (isLs && test) 
		add = "testHor ";
	
	
	
	if (this.templateMode == 1) {
	
		var buf = HeaderImageHTML();
		buf += "<div class=\"galleryIndexContainer\">";
		buf += getAdBody('main', 1);
		
		
		for (var i = startInd; i < endInd; i++) {
			
			if (ats[i] != null) {
				//buf += "<div class='galleryIndexImgDiv' onClick=\"showStory(" + i + ");\"><img style='width:105px; height:105px' src='" + ats[i].replace("w=90", "w=105").replace("h=90", "h=105") + "' onload='ImgLoad(this)' onerror='ImgError(this)'></div>";
				buf += "<div class='galleryIndexImgDiv'><a id=\"image_index_ail_" + i + "\" href=\"javascript:showStory(" + i + ")\"></a></div>";
				
			}
			else {
				buf += "<a href='#' onClick=\"showStory(" + i + ");\"><div class='galleryIndexImgDiv'><img style='width:105px; height:105px' src='imagesNew/thumb_broken.png'></div></a>";
			}
			
		}
		
		
		buf += "</div>";
		buf += "<div style='clear:both'></div>";
		buf += getAdBody('main', 2);
		buf += OviBarHTMLcode();
		return buf;
	}
	else {
	
		var buf = HeaderImageHTML();
		

		/*open the containter of articles - closes at the end*/
		buf += "<div class='articleListContainer'>";
		
		
		buf += getAdBody('main', 1);
		
		for (var i = startInd; i < endInd; i++) {
		
			if ((i == 0) && (this.templateMode == 2)) {
				var limit = 100;
				if (isLs) 
					limit = 130;

				buf += "<div id='containerOfFirstArticle'>";
				var tmpImgSrc = "";
				if (this.arrayImagesSrc != null && this.arrayImagesSrc[0] != null && this.arrayImagesSrc[0] != "") 
					tmpImgSrc = this.arrayImagesSrc[0];
				//buf += "	<div class='ImgDivFirstArticle'><img class='firstImage' src='" + this.arrayThumbsSrc[0].replace("w=120", "w=340").replace("w=90", "w=340").replace("h=90", "h=192") + "'/></div>";
				
				buf += "	<div class='ImgDivFirstArticle'><a id=\"image_index_ail_" + i + "\" href='javascript:showStory(0);'></a></div>";
				buf += "	<div><a href='javascript:showStory(0);'>"; // style='max-height:192px; overflow:hidden'
				buf += "		<div class='firstArticleTitleIndex'>";
				var tempTitle = items[0].title;
				if (tempTitle == null) 
					tempTitle = "";
				if (tempTitle.length > limit) 
					tempTitle = tempTitle.substring(0, limit) + "...";
				buf += "			<div>" + tempTitle + "</div>";
				buf += "		</div>";
				if ((isLs) && (items[0].description != null)) {
					//var tempDesc = items[0].description.replace(/\<\s*[Aa].*?\s*\>/gi, "").replace(/\<\s*\/[Aa].*?\s*\>/gi, "");
					//tempDesc = tempDesc.replace(/\<br\/\>/gi, "").replace(/\<br\>/gi, "");
					var tempDesc = items[i].description.replace(/(<([^>]+)>)/ig, "  ");
				
					if (tempDesc.length > limit) 
						tempDesc = tempDesc.substring(0, limit) + "...";
					buf += "	<div class='firstArticleDescriptionIndex'>" + tempDesc + "</div></a>";
				}
				buf += "	</div>";
				buf += "	<div class=\"font_time_indexview\">";
				var ts = this.timestamps[0];
				if (ts != null) 
					buf += ts;
				buf += "	</div>";
				buf += "	<div style='clear:both'></div>";
				buf += "	<div class=\"lineBottom\"></div>";
				buf += "</div>";
				
				continue;
			}
			
			
			buf += "<a href='#' onClick=\"showStory(" + i + ");\">";
			buf += "<table width=\"99%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" style='margin:3px 0 4px 0'><tr>";
			if (ats[i] != null) {
			
			
				buf += "<td width=\"120\" align=\"left\" valign=\"top\" class=\"image_headline_indexview\"><a id=\"image_index_ail_" + i + "\">";
				/*bill1*/
				//buf += "<td width=\"120\" align=\"left\" valign=\"top\" class=\"image_headline_indexview\"><a href=\"javascript:showStory(" + i + ")\"><img class='firstImage' src='" + this.arrayThumbsSrc[i] + "'/>";
				
				
				
				buf += "</a></td>"
				buf += "<td width=\"100%\" align=\"" + (rtol ? 'right' : 'left') + "\" valign=\"top\" style=\"cursor:pointer;cursor:hand\"><div class=\"font_headline_indexview_img" + (rtol ? ' rtol' : '') + "\">";
				buf += add;
				var limit = 115;
				if (isLs) 
					limit = 140;
				var hasLeft = limit;
				if (items[i].title != null) {
					if (items[i].title.length > limit) {
						buf += items[i].title.substring(0, limit) + "...";
						hasLeft = hasLeft - limit;
					}
					else {
						buf += items[i].title;
						hasLeft = hasLeft - items[i].title.length;
					}
				}
				if (isLs && hasLeft > 0) {
					buf += "</div><div class=\"font_story_indexview_img" + (rtol ? ' rtol' : '') + "\">";
					if (items[i].description != null) {
						var toAdd = "";
						//var tempDesc = items[i].description.replace(/\<\s*[Aa].*?\s*\>/gi, "").replace(/\<\s*\/[Aa].*?\s*\>/gi, "");
						//tempDesc = tempDesc.replace(/\<br\/\>/gi, "").replace(/\<br\>/gi, "");
						var tempDesc = items[i].description.replace(/(<([^>]+)>)/ig, "  ");
						
						if (tempDesc.length > hasLeft) {
						
							toAdd += tempDesc.substring(0, hasLeft) + "...";
						}
						else {
							toAdd += tempDesc;
						}
						var nextBr = toAdd.indexOf("<br/>", 0);
						if (nextBr != -1) {
							nextBr = toAdd.indexOf("<br/>", nextBr);
							if (nextBr != -1) {
								toAdd = toAdd.substring(0, nextBr);
							}
						}
						buf += toAdd;
					}
				}
				buf += "</div><div class=\"font_time_indexview" + (rtol ? ' rtol' : '') + "\">";
				var ts = this.timestamps[i];
				if (ts != null) {
					buf += ts;
					
				}
				buf += "</div></td>"
				
			}
			else {
				var limit = 115;
				if (isLs) 
					limit = 160;
				buf += "<td width=\"100%\" align=\"" + (rtol ? 'right' : 'left') + "\" valign=\"top\" style=\"cursor:pointer;cursor:hand\"><div class=\"font_headline_indexview" + (rtol ? ' rtol' : '') + "\">";
				var hasLeft = limit;
				if (items[i].title != null) {
					if (items[i].title.length > limit) {
						buf += items[i].title.substring(0, limit) + "...";
						hasLeft = hasLeft - limit;
					}
					else {
						buf += items[i].title;
						hasLeft = hasLeft - items[i].title.length;
					}
				}
				if (!isLs) 
					hasLeft = 115;
				buf += "</div><div class=\"font_story_indexview" + (rtol ? ' rtol' : '') + "\">";
				//var tempDesc = items[i].description.replace(/\<\s*[Aa].*?\s*\>/gi, "").replace(/\<\s*\/[Aa].*?\s*\>/gi, "");
				//tempDesc = tempDesc.replace(/\<br\/\>/gi, "").replace(/\<br\>/gi, "");
				var tempDesc = items[i].description.replace(/(<([^>]+)>)/ig, "  ");
				
				if (tempDesc != null) {
					if (tempDesc.length > hasLeft) {
						buf += tempDesc.substring(0, hasLeft) + "...";
					}
					else {
						buf += tempDesc;
					}
				}
				buf += "</div><div class=\"font_time_indexview" + (rtol ? ' rtol' : '') + "\">";
				var ts = this.timestamps[i];
				if (ts != null) {
					buf += ts;
					
				}
				buf += "</div></td>"
			}
			
			buf += "</tr></table>";
			buf += "</a>";
			if (i < items.length - 1) {
				buf += "<div class=\"lineBottom\"></div>";
			}
			
		}
		
		
		
		
		buf += getAdBody('main', 2);
		
		
		/*close the container of the articles*/
		buf += "</div>";
		
		
		/*bill*/
		buf += OviBarHTMLcode();
		
		
		
		return buf;
	}
}


Channel.prototype.saveAllItems = function(){
	var items = this.currentItems;
	if (items==null || items.length==0) return;
	var length = items.length;
	
	// Phong added
	pItems = this.currentItems;
	pMax = length;
	pId = this.id;
	pTemplate = this.templateMode;
	pLen = 0;
	delay('writePref();', 1000);
	// end
}
// Phong added
var pLen = 0;
var pMax = 0;
var pId =  '';
var pTemplate = 0;
var pItems = null;
function writePref(){
	
	var time = new Date().getTime();
	window.widget.setPreferenceForKey(time, mippinID + "lastUpdate_c" + pId);
	
	window.widget.setPreferenceForKey(pTemplate, mippinID+"channelTemplate_c"+pId);
	
	if (pLen < pMax){
		var storyEl = '';
		if (pItems[pLen].title!=null) storyEl += pItems[pLen].title+"t3k_89";
		else storyEl += "nullt3k_89";
		if (pItems[pLen].date!=null) storyEl += pItems[pLen].date+"t3k_89";
		else storyEl += "nullt3k_89";
		if (pItems[pLen].description!=null) storyEl += pItems[pLen].description+"t3k_89";
		else storyEl += "nullt3k_89";
		if (pItems[pLen].url!=null) storyEl += pItems[pLen].url+"t3k_89";
		else storyEl +="nullt3k_89";
		if (pItems[pLen].image!=null) storyEl += pItems[pLen].image+"t3k_89";
		else storyEl += "nullt3k_89";
		if (pItems[pLen].imageThumb!=null) storyEl += pItems[pLen].imageThumb+"t3k_89";
		else storyEl +="nullt3k_89";
		if (pItems[pLen].enclosure!=null) storyEl += pItems[pLen].enclosure+"t3k_89";
		else storyEl += "nullt3k_89";
		if (pItems[pLen].mippinTitle!=null) storyEl += pItems[pLen].mippinTitle+"t3k_89";
		else storyEl += "nullt3k_89";
		if (pItems[pLen].mippinUrl!=null) storyEl += pItems[pLen].mippinUrl+"t3k_89";
		else storyEl += "nullt3k_89";
		if (pItems[pLen].mipSource!=null) storyEl += pItems[pLen].mipSource+"t3k_89";
		else storyEl += "nullt3k_89";
		if (pItems[pLen].icon!=null) storyEl += pItems[pLen].icon+"t3k_89";
		else storyEl += "nullt3k_89";
		if (pItems[pLen].upgrade!=null) storyEl += pItems[pLen].upgrade+"t3k_89";
		else storyEl += "nullt3k_89";
		if (pItems[pLen].track!=null) storyEl += pItems[pLen].track+"t3k_89";
		else storyEl += "nullt3k_89";
		if (pItems[pLen].audio!=null && pItems[pLen].audio.length>0) {
			var sp=pItems[pLen].audio[0];
			for (var j=1;j<pItems[pLen].audio.length;j++){
				sp = sp+";"+pItems[pLen].audio[j];
			}
			storyEl+= sp;
		} else storyEl+="null";
		
		window.widget.setPreferenceForKey(storyEl, mippinID+"c"+pId+"item"+pLen);
		window.widget.setPreferenceForKey(pLen+1, mippinID+"c"+pId+"itemsLength"); 
		pLen++;
		delay('writePref();', 50);
	}
}
// end

Channel.prototype.readAllItems = function(){
	var win = window.widget;
	var length = win.preferenceForKey(mippinID+"c"+this.id+"itemsLength"); 
	var items=[];
	if (length==null || length==0) return items;
	for (var i = 0; i< length; i++){
		var ar = getValueForWidget(mippinID+"c"+this.id+"item"+i);
		if (ar == null) 
			console.log("ar is null!!");
		else {
			var title = null;
			if (ar[0] != "null") 
				title = ar[0];
			var date = null;
			if (ar[1] != "null") 
				date = ar[1];
			var description = null;
			if (ar[2] != "null") 
				description = ar[2];
			var url = null;
			if (ar[3] != "null") 
				url = ar[3];
			var image = null;
			if (ar[4] != "null") 
				image = ar[4];
			var imageThumb = null;
			if (ar[5] != "null") 
				imageThumb = ar[5];
			var enclosure = null;
			if (ar[6] != "null") 
				enclosure = ar[6];
			var mippinTitle = null;
			if (ar[7] != "null") 
				mippinTitle = ar[7];
			var mippinUrl = null;
			if (ar[8] != "null") 
				mippinUrl = ar[8];
			var mipSource = null;
			if (ar[9] != "null") 
				mipSource = ar[9];
			var icon = null;
			if (ar[10] != "null") 
				icon = ar[10];
			var upgrade = null;
			if (ar[11] != "null") 
				upgrade = ar[11];
			var track = null;
			if (ar[12] != "null") 
				track = ar[12];
			var audio = [];
			if (ar[13] != "null") {
				var sp = ar[13].split(";");
				for (var j = 0; j < sp.length; j++) {
					audio.push(sp[j]);
				}
			}
			
			items.push({
				title: title,
				date: date,
				description: description,
				url: url,
				image: image,
				imageThumb: imageThumb,
				enclosure: enclosure,
				mippinTitle: mippinTitle,
				mippinUrl: mippinUrl,
				mipSource: mipSource,
				icon: icon,
				upgrade: upgrade,
				track: track,
				audio: audio
			});
		}   
	}
	return items;
}

// Callback function that gets called when a feed update has completed.
Channel.prototype.feedUpdateCompleted = function(event){
	var areChangesPostponed = false;
	if (event.status == "ok") {
		// check if the feed has updated
		if (event.lastModified != this.channelOb.feedLastModified) {
			// remember the last modified timestamp
			this.channelOb.feedLastModified = event.lastModified;
			adnum = event.adnum;
			if (adnum == 0) 
				adsHTML = [];
			var count = event.channelCount;
			if (count != -1) {
				setChannels(count, event.channelTitles);
				this.channelOb.templateMode = event.template;
			}
			
			areChangesPostponed = this.channelOb.setFeedItems(event.items,true);
		}
		
	}
	else {
		// show error message
		//		showNoti();
		//       uiManager.showNotification(3000, "warning", "network error<br/>(loading cached content)</br></br></br></br></br>");
		this.channelOb.setFeedItems(null,true);
		
	}
	
	// null the broker reference to indicate that there's no current
	// update in progress
	this.channelOb.mippinUpdate = null;
	this.channelOb.feedLastModified = new Date().getTime();
	this.channelOb.isUpdating = false;

	if (!areChangesPostponed) {
		if (currentChannel == this.channelOb.id && this.channelOb.currentItems == null) {
			setTimeout("hideWaiter(" + this.id + ")", 25000);
		}
		else {
			setTimeout("hideWaiter(" + this.id + ")", 1000);
		}
	}
	
}

Channel.prototype.showStory = function(i){
	if (currentChannel!=this.id) return;
    this.showStoriesView();
    this.setStoryVisible(i,true);
    this.currentStory = i;
    this.setTitle();
}

Channel.prototype.setTitle = function(){
    if (currentChannel!=this.id) return;
    var isInMiniView = helper.isMiniViewMode();
    if (isInMiniView) 
        return;
    
    if (uiManager.getView() == this.mainView || uiManager.getView() == this.mainViewLs) {
	 	this.shareUrl = mippinUrl;
    }    
}

Channel.prototype.removeAllItems = function(){
  var iddd = this.id;
  var obj = this.arrayImagesListSrc;
   for (var i=0; i<obj.length; i++){
   		obj[i] = null;
   }
   obj = this.arrayImages;
   for (var i=0; i<obj.length; i++){
   		obj[i] = null;
   }
   obj = this.arrayImagesList;
   for (var i=0; i<obj.length; i++){
   		obj[i] = null;
   }
   obj = this.arrayThumbs;
   for (var i=0; i<obj.length; i++){
   		obj[i] = null;
   }
   obj = this.arrayImagesSrc;
   for (var i=0; i<obj.length; i++){
   		obj[i] = null;
   }
   obj = this.arrayThumbsSrc;
   for (var i=0; i<obj.length; i++){
   		obj[i] = null;
   }
   obj = this.timestamps;
   for (var i=0; i<obj.length; i++){
   		obj[i] = null;
   }
   var obList = this.mainPageItemControls;
   var view = this.mainView;
   if (obList) 
   for (var i = 0; i < obList.length; i++) {
      	view.removeControl(obList[i]);
   }
   obList = this.mainPageItemControlsLs;
   view = this.mainViewLs;
   if (obList) 
   for (var i = 0; i < obList.length; i++) {
      	view.removeControl(obList[i]);
   }
   obList = this.feedItemControls;
   view = this.storiesView;
   if (obList) 
   for (var i = 0; i < obList.length; i++) {
      	view.removeControl(obList[i]);
   }
   obList = this.feedItemControlsLs;
   view = this.storiesViewLs;
   if (obList) 
   for (var i = 0; i < obList.length; i++) {
      	view.removeControl(obList[i]);
   }
   obj = this.feedItemControls;
   for (var i=0; i<obj.length; i++){
   		obj[i] = null;
   }
   obj = this.feedItemControlsLs;
   for (var i=0; i<obj.length; i++){
   		obj[i] = null;
   }
   obj = this.mainPageItemControls;
   for (var i=0; i<obj.length; i++){
   		obj[i] = null;
   }
   obj = this.mainPageItemControlsLs;
   for (var i=0; i<obj.length; i++){
   		obj[i] = null;
   }
   
}
Channel.prototype.clearAdArray = function(){
   var obj = this.pageSeen;
	for (var i=0; i<obj.length; i++){
	   		obj[i] = null;
	}
  
}

Channel.prototype.showStoriesView = function(){
	if (currentChannel!=this.id) return;
    if (this.currentItems==null || this.currentItems.length == 0) 
        setTimeout("showWaiter("+this.id+")", 1000);
    if (uiManager.getView() != this.storiesView) {
        if (uiManager.getView() == this.mainView) {
			lastTopMain = window.pageYOffset;
			if (this.currentPage < this.mainPageItemControls.length) this.mainPageItemControls[this.currentPage].setVisible(false);
		} else if (uiManager.getView() == this.mainViewLs){
			lastTopMain = window.pageYOffset;
			if (this.currentPage < this.mainPageItemControlsLs.length) this.mainPageItemControlsLs[this.currentPage].setVisible(false);
		} 
    	uiManager.setView(this.storiesView);
		this.widgetOb.checkOrientation();
	} else {
		this.widgetOb.checkOrientation();
	}
	
//	doAd();
    
}

Channel.prototype.setCurrentStoryVisible = function(clearPosition){
	this.setStoryVisible(this.currentStory,clearPosition);
}

Channel.prototype.setStoryVisible = function(ind,clearPosition){
    if (currentChannel!=this.id) return;
    var fic;
	if (uiManager.getView() == this.storiesViewLs) fic = this.feedItemControlsLs;
	else if (uiManager.getView() == this.storiesView) fic = this.feedItemControls;
	else if (isWide){
		uiManager.setView(this.storiesViewLs);
		fic = this.feedItemControlsLs;
	} else {
		uiManager.setView(this.storiesView);
		fic = this.feedItemControls;
	}
   
    var cs = this.countStory;
    var ais= this.arrayImagesSrc;
    var ail= this.arrayImagesList;
    var ails= this.arrayImagesListSrc;
	var ai= this.arrayImages;
	var doc = document;
    for (var i = 0; i < cs; i++) {
        if (i == ind) {
        	var ele = doc.getElementById('image_ai_'+i);
    		if (ele) {
    			if (ais[i] && ai[i]==null) {
    				ai[i] = new Image();
    				ai[i].name="image_ai"+i;
    		    	ai[i].src = ais[i];
    			}
				if(ai[i]!=null && ai[i].src!=null) ele.innerHTML = "<img src=\"" + ai[i].src + "\" alt=\"\" />";
    		}
    		var ele = doc.getElementById('image_ail_'+i);
    		if (ele) {
    			if (ails[i] && ail[i]==null) {
    				ail[i] = new Image();
    				ail[i].name="image_ail"+i;
    		    	ail[i].src = ails[i];
    			}
    			ele.innerHTML = "<img src=\"" + ail[i].src + "\" border=\"0\">";
    		}
			doAd(false,i);
        	if (clearPosition) lastTopStory =0;
			fic[i].setVisible(true);
        	fic[i].setFocused(true);
			window.scrollTo(0,lastTopStory);
			this.currentStory=ind;
        }
        else 
        	fic[i].setVisible(false);
    };
	if (this.currentItems != null) {
		this.shareUrl = this.currentItems[this.currentStory].mippinUrl;
		this.shareTitle = this.currentItems[this.currentStory].title;
	}
    this.doTrack(ind);
}
Channel.prototype.doTrack = function(id){
	if (this.pageSeen[id]==null) {
		this.pageSeen[id]=1;
		if (this.currentItems[id].track != null) {
	    	var trackUrl= this.currentItems[id].track+"&uid="+imei+"&ttt="+new Date().getTime();
			var httpRequest = new XMLHttpRequest();
		    try {
				httpRequest.open("GET", trackUrl, true);
				httpRequest.send(null);
			} catch (err){
				
			}
	    }
	}
}

Channel.prototype.showMainView = function(){
    if (currentChannel!=this.id) return;
    var help = helper;
    if (this.currentItems==null || this.currentItems.length == 0) 
        setTimeout("showWaiter("+this.id+")", 10);
	if (uiManager.getView() != this.mainView) {
        if (uiManager.getView() == this.storiesView) {
			lastTopStory = window.pageYOffset;
			if (this.currentStory < this.feedItemControls.length) this.feedItemControls[this.currentStory].setVisible(false);
		} else if (uiManager.getView() == this.storiesViewLs){
			lastTopStory = window.pageYOffset;
			if (this.currentStory < this.feedItemControlsLs.length) this.feedItemControlsLs[this.currentStory].setVisible(false);
		}  	
        var tempLastTop = lastTopMain;
		uiManager.setView(this.mainView);
		this.widgetOb.checkOrientation();
		lastTopMain = tempLastTop;
		this.setMainPageVisible(0,false);
    } else {
		this.widgetOb.checkOrientation();
	}
    this.setTitle();
	
//    doAd();
}

Channel.prototype.setCurrentMainPageVisible = function(clearPosition){
	this.setMainPageVisible(this.currentPage,clearPosition);
}

var pImg = new Array();
Channel.prototype.setMainPageVisible = function(ind,clearPosition){
    if (currentChannel!=this.id || this.currentItems==null) return;
	if (channelsToUpdate[this.id]!=null) {
		showWaiter(this.id);
		this.isUpdating = true;
		this.setFeedItems(channelsToUpdate[this.id],false);
		channelsToUpdate[this.id]=null;
		this.isUpdating = false;
		hideWaiter(this.id);
	} else if (this.isUpdating) showWaiter(this.id);
	else hideWaiter(this.id);
	var mpic;
	if (uiManager.getView() == this.mainViewLs) mpic = this.mainPageItemControlsLs;
	else mpic = this.mainPageItemControls;
    var cp = this.countPage;
	var doc = document;
    var ail= this.arrayImagesList;
    var ails= this.arrayImagesListSrc;
    var length =this.currentItems.length;
	
	while(pImg.length) pImg.pop();
	
	for (var j=0; j<length;j++) {
		var ele = doc.getElementById('image_index_ail_'+j);
		if (ele && (ails[j] && ail[j]==null)) {
			//if (ails[j] && ail[j]==null) {
				ail[j] = new Image();
				ail[j].name="image_ail"+j;
				/*bill-*/
				if ((this.templateMode == 2) && (j == 0)) 
					ail[j].src = ails[j].replace("w=120", "w=340").replace("w=90", "w=340").replace("h=90", "h=192");
				else if (this.templateMode == 1)
					ail[j].src = ails[j].replace("w=120", "w=105").replace("w=90", "w=105").replace("h=90", "h=105");
				else 
					ail[j].src = ails[j];
			//}
			// Phong added
			/*bill*/
			if ((j == 0) && (this.templateMode == 2))
				ele.innerHTML = "<img id='i" + j + "' class='firstImage' src='imagesNew/empty-spotlight.gif' width=\"340\" height=\"192\" border=\"0\"><br/>";
			//too heavy
			else if (this.templateMode == 1)
				ele.innerHTML = "<img id='i" + j + "' src='imagesNew/empty.png' width=\"105\" height=\"105\" border=\"0\" onload='ImgLoad(this)' onerror='ImgError(this)'><br/>";
			else
				ele.innerHTML = "<img id='i" + j + "' src='imagesNew/empty.gif' width=\"90\" height=\"90\" border=\"0\"><br/>";
				
			pImg.push(ail[j].src);
		}
		// Phong added
		else {
			pImg.push("empty.png");
		}

	}
	doAd(true,null);
    for (var i = 0; i < cp; i++) {
        if (i == ind) {
        	if (clearPosition) lastTopMain =0;
			mpic[i].setVisible(true);
        	mpic[i].setFocused(true);
			window.scrollTo(0,lastTopMain);
			this.currentPage=ind;
        }
        else 
        	mpic[i].setVisible(false);
    };
	this.shareUrl =mippinUrl;
	this.shareTitle='Ovi app wizard';
	// Phong added
    if (pImg.length)
    {
		pIndex=0;
		delay('loadImage();', 20);
		//this.ResumeImagesIfNeeded(150);
    }

}

Channel.prototype.updateContent = function(){
	var now = new Date().getTime();
	// check if a feed update has been scheduled, if it's time to update now,
	// and if there's no update currently in progress and if we're in the main view
	if (this.mippinUpdate != null && this.mippinUpdateStart < now - 300000) 
		this.mippinUpdate == null;
	if ((feedURL != null) &&
	(this.feedUpdateTime != -1) &&
	(now > this.feedUpdateTime) &&
	(this.mippinUpdate == null)) {
		this.refresh();
	} 
}

Channel.prototype.refresh = function(){
	if (this.mippinUpdate!=null && this.mippinUpdateStart<(new Date().getTime()-300000)) this.mippinUpdate = null;
	if ((this.mippinUpdate == null) && (feedURL != null)) {
		 /*-------------------------------bill*/
		//runHome();
		hideAbout();
		hideUpdateNow();
		//------------------------
		this.isUpdating = true;
		if (currentChannel==this.id && this.isMainView()) setTimeout("showWaiter("+this.id+")", 1000);
		// fetch the feed from the specified URL
		this.mippinUpdate = new MippinUpdate();
		this.mippinUpdateStart = new Date().getTime();
		this.mippinUpdate.fetchFeed(feedURL+"&c="+this.id, this.feedUpdateCompleted,this);
		if (!isWidget) feedUpdateFrequency = -1;
		else feedUpdateFrequency = feedUpdateFrequencyStatic;
		if (feedUpdateFrequency != -1) {
			var now = new Date().getTime();
    		// schedule next update
			this.feedUpdateTime = now + feedUpdateFrequency;
		}
		else {
			// feed update frequency is "never"
			this.feedUpdateTime = -1;
		}
	}
}


Channel.prototype.isStoryView = function(){
	if (uiManager.getView() == this.storiesView || uiManager.getView() == this.storiesViewLs) return true;
}
Channel.prototype.isMainView = function(){
	if (uiManager.getView() == this.mainView || uiManager.getView() == this.mainViewLs) return true;
}
Channel.prototype.changeStoryHomeView = function(){
	    this.currentStory=this.currentStory+1;
        if ((this.currentStory >= this.countStory) || (this.currentStory>9)) 
            this.currentStory = 0;
        homeScreenWidget(this.currentStory);
}

Channel.prototype.clearImages = function(){
	this.arrayImages = new Array(20);
    this.arrayImagesList = new Array(20);
}

Channel.prototype.nextSlide = function(){
   if (uiManager.getView() == this.mainView || uiManager.getView() == this.mainViewLs) {
        this.currentPage++;
        if (this.currentPage >= this.countPage) 
            this.currentPage = 0;
        this.setMainPageVisible(this.currentPage,true);
    }
    else 
        if (uiManager.getView() == this.storiesView || uiManager.getView() == this.storiesViewLs) {
            this.currentStory++;
            if (this.currentStory >= this.countStory) 
                this.currentStory = 0;
            this.setCurrentStoryVisible(true);
        }
    this.setTitle();
    
}

Channel.prototype.previousSlide = function(){
	if (uiManager.getView() == this.mainView || uiManager.getView() == this.mainViewLs) {
        if (this.currentPage >= this.countPage) 
            this.currentPage = this.countPage - 1;
        if (this.currentPage < 0) 
            this.currentPage = 0;
        this.currentPage--;
        if (this.currentPage < 0) 
            this.currentPage = this.countPage - 1;
        this.setMainPageVisible(this.currentPage,true);
    }
    else 
        if (uiManager.getView() == this.storiesView || uiManager.getView() == this.storiesViewLs) {
            if (this.currentStory >= this.countStory) 
                this.currentStory = this.countStory - 1;
            if (this.currentStory < 0) 
                this.currentStory = 0;
            this.currentStory--;
            if (this.currentStory < 0) 
                this.currentStory = this.countStory - 1;
            this.setCurrentStoryVisible(true);
            homeScreenWidget(this.currentStory);
        }
    this.setTitle();
    
}
Channel.prototype.saveAllCurrentItems = function(){
 	this.saveAllItems(this.currentItems);
}

Channel.prototype.share = function(){
	if (this.currentItems==null) return;
    helper.show("sharebox",true);
	showVeil('darkall');
}
Channel.prototype.shareApp = function(){
	window.location.href = "sms:?body="+siteText+" "+this.shareUrl;
}

Channel.prototype.sendSMS = function(){
	if (uiManager.getView() == this.storiesView || uiManager.getView() == this.storiesViewLs) {
		window.location.href = "sms:?body="+articleText+" "+this.shareUrl;	
	}
}

Channel.prototype.sendEmail = function(){
	if (uiManager.getView() == this.storiesView || uiManager.getView() == this.storiesViewLs) {
		window.location.href = "mailto:?body="+articleText+" "+this.shareUrl;	
	} else if (uiManager.getView() == this.mainView || uiManager.getView() == this.mainViewLs) {
		window.location.href = "mailto:?body="+siteText+" "+this.shareUrl;
	}
}

Channel.prototype.sendTwitter = function(){
	if (uiManager.getView() == this.storiesView || uiManager.getView() == this.storiesViewLs) {
		window.widget.openURL("http://mobile.twitter.com/?status="+this.shareUrl.replace('&','%26'));	
	}
}

Channel.prototype.sendFacebook = function(){
	if (uiManager.getView() == this.storiesView || uiManager.getView() == this.storiesViewLs) {
		window.widget.openURL("http://m.facebook.com/sharer.php?u="+this.shareUrl.replace('&','%26'));
	}
}

// Phong added
var pIndex = 0;
var pTimer = null;
function loadImage(){
	i = pImg.length;
	if (i > 0)	{
		var srcUrl = pImg.shift();
		if (srcUrl == "empty.png")	{
			pIndex++;
			loadImage();
			return;
		}
		var imgR = getE("i"+pIndex);
		if (imgR != null) {
			imgR.setAttribute("onload", "delay('loadImage();', 20);");
			imgR.setAttribute("onerror", "ImgError(getE('i" + pIndex + "')); delay('loadImage();', 20);");
			imgR.setAttribute("src", srcUrl);
		}
		pIndex++;
		pTimer = null;
	}
	else{
		pIndex =0;
		pTimer = null;		
	}
}
function delay(func, period){
	pTimer = window.setTimeout(func, period);
}




Channel.prototype.ResumeImagesIfNeeded = function(duration){
	var doc = document;
	var ail = this.arrayImagesList;
	var ails = this.arrayImagesListSrc;
	var length = this.currentItems.length;
	
	var cc_counter = 0;
	
	for (var j = 0; j < length; j++) {
		var ele = doc.getElementById('image_index_ail_' + j);
		if (ele && (ails[j] != null) && (ails[j] != "")) {
			
			
			var imgR = getE("i" + j);
			
			if ((imgR != null) && (/imagesNew\/empty-spotlight\.gif$/.test(imgR.src))) {
				imgR.setAttribute("onerror", "ImgError(this);");
				imgR.setAttribute("onload", "ImgLoad(this);");
				delay('if (getE("i' + j + '") != null) getE("i' + j + '").setAttribute("src", channels[currentChannel].arrayImagesListSrc[' + j + '].replace("w=120", "w=340").replace("w=90", "w=340").replace("h=90", "h=192"));', cc_counter*duration);
				cc_counter++;
			}
			else if ((imgR != null) && 
				( (/imagesNew\/empty\.gif$/.test(imgR.src)) || (/imagesNew\/thumb_broken\.png$/.test(imgR.src)) || (/imagesNew\/empty\.png$/.test(imgR.src)) || (imgR.src == "") || (imgR.src == "undefined")) ) {
				imgR.setAttribute("onerror", "ImgError(this);");
				imgR.setAttribute("onload", "ImgLoad(this);");
				if (this.templateMode == 1)
					delay('if (getE("i' + j + '") != null) getE("i' + j + '").setAttribute("src", channels[currentChannel].arrayImagesListSrc[' + j + '].replace("w=120", "w=105").replace("w=90", "w=105").replace("h=90", "h=105"));', cc_counter*duration);
				else
					delay('if (getE("i' + j + '") != null) getE("i' + j + '").setAttribute("src", channels[currentChannel].arrayImagesListSrc[' + j + ']);', cc_counter*duration);
				cc_counter++;
			}
			else {
				//console.debug("DONT UPDATE: img" + j + "is null or ails null");
			}
		}
	}
}

